/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.equivalencia;

import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaEquivalencia;
import com.rjconsultores.ventaboletos.service.ComisionistaExternoService;
import com.rjconsultores.ventaboletos.service.EmpresaEquivalenciaService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarEmpresaEquivalenciaController")
@Scope("prototype")
public class EditarEmpresaEquivalenciaController extends MyGenericForwardComposer {

    @Autowired
    private EmpresaEquivalenciaService empresaEquivalenciaService;
    @Autowired
    private ComisionistaExternoService comisionistaExternoService;
    @Autowired
    private EmpresaService empresaService;
    private EmpresaEquivalencia empresaEquivalencia;
    private MyListbox empresaEquivalenciaList;
    private static Logger log = Logger.getLogger(EditarEmpresaEquivalenciaController.class);
    private List<ComisionistaExterno> lsComisionistaExterno;
    private List<Empresa> lsEmpresas;
    private Combobox cmbEmpresa;
    private Combobox cmbComissionestaExterno;
    private Textbox txtEquivalencia;
    private Button btnApagar;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Combobox getCmbComissionestaExterno() {
        return cmbComissionestaExterno;
    }

    public void setCmbComissionestaExterno(Combobox cmbComissionestaExterno) {
        this.cmbComissionestaExterno = cmbComissionestaExterno;
    }

    public Combobox getCmbEmpresa() {
        return cmbEmpresa;
    }

    public void setCmbEmpresa(Combobox cmbEmpresa) {
        this.cmbEmpresa = cmbEmpresa;
    }

    public EmpresaEquivalencia getEmpresaEquivalencia() {
        return empresaEquivalencia;
    }

    public void setEmpresaEquivalencia(EmpresaEquivalencia empresaEquivalencia) {
        this.empresaEquivalencia = empresaEquivalencia;
    }

    public List<ComisionistaExterno> getLsComisionistaExterno() {
        return lsComisionistaExterno;
    }

    public void setLsComisionistaExterno(List<ComisionistaExterno> lsComisionistaExterno) {
        this.lsComisionistaExterno = lsComisionistaExterno;
    }

    public List<Empresa> getLsEmpresas() {
        return lsEmpresas;
    }

    public void setLsEmpresas(List<Empresa> lsEmpresas) {
        this.lsEmpresas = lsEmpresas;
    }

    public Textbox getTxtEquivalencia() {
        return txtEquivalencia;
    }

    public void setTxtEquivalencia(Textbox txtEquivalencia) {
        this.txtEquivalencia = txtEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsComisionistaExterno = comisionistaExternoService.obtenerTodos();
        lsEmpresas = empresaService.buscarTodosExceto(UsuarioLogado.getUsuarioLogado().getEmpresa(),-1);

        super.doAfterCompose(comp);

        empresaEquivalencia = (EmpresaEquivalencia) Executions.getCurrent().getArg().get("empresaEquivalencia");
        empresaEquivalenciaList = (MyListbox) Executions.getCurrent().getArg().get("empresaEquivalenciaList");

        if (empresaEquivalencia.getEmpresaequivalenciaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            cmbEmpresa.setDisabled(true);
            cmbComissionestaExterno.setDisabled(true);
        }

        cmbEmpresa.setFocus(true);
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        cmbComissionestaExterno.getSelectedItem();
        cmbEmpresa.getSelectedItem();
        txtEquivalencia.getText();

        try {
            ComisionistaExterno comisionistaExterno = empresaEquivalencia.getComisionistaExterno();
            Comboitem cbiParada = cmbEmpresa.getSelectedItem();
            Empresa empresa = null;
            if (cbiParada != null) {
                empresa = (Empresa) cbiParada.getValue();
                empresaEquivalencia.setEmpresa(empresa);
            }

            List<EmpresaEquivalencia> lsEmpresaEquivalente =
                    empresaEquivalenciaService.buscar(empresa, comisionistaExterno);

            boolean podeSalvar = false;
            if (lsEmpresaEquivalente.isEmpty()) {
                podeSalvar = true;
            } else {
                if (empresaEquivalencia.getEmpresaequivalenciaId() != null) {
                    for (EmpresaEquivalencia p : lsEmpresaEquivalente) {
                        if (p.getEmpresaequivalenciaId().equals(empresaEquivalencia.getEmpresaequivalenciaId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }

            List<EmpresaEquivalencia> lsEquivalente =
                    empresaEquivalenciaService.buscarEquivalencia(empresaEquivalencia);

            boolean podeSalvarEquivalencia = false;
            if (lsEquivalente.isEmpty()) {
                podeSalvarEquivalencia = true;
            } else {
                if (empresaEquivalencia.getEmpresaequivalenciaId() != null) {
                    for (EmpresaEquivalencia p : lsEquivalente) {
                        if (p.getEmpresaequivalenciaId().equals(empresaEquivalencia.getEmpresaequivalenciaId())) {
                            podeSalvarEquivalencia = true;
                        }
                    }
                }
            }

            if (!podeSalvarEquivalencia) {
                Messagebox.show(
                        Labels.getLabel("MSG.Equivalencia.Existe"),
                        Labels.getLabel("editarEmpresaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }

            if (podeSalvar) {

                if (empresaEquivalencia.getEmpresaequivalenciaId() == null) {
                    empresaEquivalenciaService.suscribir(empresaEquivalencia);
                    empresaEquivalenciaList.addItem(empresaEquivalencia);

                } else {
                    empresaEquivalenciaService.actualizacion(empresaEquivalencia);
                    empresaEquivalenciaList.updateItem(empresaEquivalencia);
                }
                Messagebox.show(
                        Labels.getLabel("editarEmpresaEquivalenciaController.MSG.suscribirOK"),
                        Labels.getLabel("editarEmpresaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarEmpresaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarEmpresaEquivalenciaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);

        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarEmpresaEquivalenciaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarEmpresaEquivalenciaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                empresaEquivalenciaService.borrar(empresaEquivalencia);

                Messagebox.show(
                        Labels.getLabel("editarEmpresaEquivalenciaController.MSG.borrarOK"),
                        Labels.getLabel("editarEmpresaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                empresaEquivalenciaList.removeItem(empresaEquivalencia);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
